//============================================================================
// Name        : Flugobjekt.cpp
// Author      : Manuel Mauky <lestard@esrix.de>
// Version     :
// Copyright   : GPL
// Description : SpaceShooter
//============================================================================



#include "UtilsConsole.h"
#include "Flugobjekt.h"

	int Flugobjekt::getX(){
		return x;
	}


	int Flugobjekt::getY(){
		return y;
	}

	void Flugobjekt::setX(int x){
		this->x = x;
	}

	void Flugobjekt::setY(int y){
		this->y = y;
	}

	void Flugobjekt::setOldX(int x){
		this->oldX = x;
	}

	void Flugobjekt::setOldY(int y){
		this->oldY = y;
	}


	bool Flugobjekt::getInit(){
		return init;
	}


	void Flugobjekt::setInit(bool _init){
		init = _init;
	}

	int Flugobjekt::getColor(){
		return color;
	}

	void Flugobjekt::setColor(int color){
		this->color = color;
	}



	void Flugobjekt::draw(){

			UtilsConsole::setCursor(x,y);

			UtilsConsole::setColor(color);
			cout<<form;
			UtilsConsole::setColor(UtilsConsole::grey);

			unDraw(oldX, oldY);
	}


	void Flugobjekt::unDraw(int x, int y){
		UtilsConsole::setCursor(x,y);
		cout<<" ";
	}


	void Flugobjekt::kaputt(int z){
		UtilsConsole::setCursor(x,y);
		switch(z){
			case 1:
				UtilsConsole::setColor(UtilsConsole::red);
				cout<<"*";
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
			case 2:
				UtilsConsole::setColor(UtilsConsole::hred);
				cout<<"#";
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
			case 3:
				UtilsConsole::setColor(UtilsConsole::hred);
				cout<<"O";
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
			case 4:
				UtilsConsole::setColor(UtilsConsole::hyellow);
				cout<<(char)176;
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
			case 5:
				UtilsConsole::setColor(UtilsConsole::hyellow);
				cout<<(char)177;
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
			case 6:
				UtilsConsole::setColor(UtilsConsole::hred);
				cout<<(char)178;
				UtilsConsole::setColor(UtilsConsole::grey);
				break;
		}
	}



	Flugobjekt::Flugobjekt(){


			x = 1;
			y = 1;

			oldX = 1;
			oldY = 1;

			init = false;


			form = ' ';


			color = UtilsConsole::grey;


		}

	Flugobjekt::Flugobjekt(int x, int y){


			this->x = x;
			this->y = y;

			this->oldX = x;
			this->oldY = y;

			init = false;

			form = ' ';

			color = UtilsConsole::grey;

	}

	bool Flugobjekt::kollisionWand(){

		if(y>14){
			return true;
		}
		if(UtilsConsole::getCharFromConsole(x,y) == '*'){
			return true;
		}else{
			return false;
		}


	}



	void Flugobjekt::goLeft(){



			setOldX(x);
			setOldY(y);

			setX(x - 1);
			setY(y);



			if(!kollisionWand()){
				draw();
			}else{
				setX(x+1);
			}


	}

	void Flugobjekt::goRight(){


			setOldX(x);
			setOldY(y);

			setX(x + 1);
			setY(y);



			if(!kollisionWand()){
				draw();
			}else{
				setX(x-1);
			}

	}

	void Flugobjekt::goUp(){

			setOldX(x);
			setOldY(y);

			setX(x);
			setY(y - 1);


			if(!kollisionWand()){
				draw();
			}else{
				setY(y + 1);
			}

	}

	void Flugobjekt::goDown(){

			setOldX(x);
			setOldY(y);

			setX(x);
			setY(y + 1);


			if(!kollisionWand()){
				draw();
			}else{
				setY(y - 1);
			}

	}

