//============================================================================
// Name        : Projekt_Space.cpp
// Author      : Manuel Mauky <lestard@esrix.de>
// Version     :
// Copyright   : GPL
// Description : SpaceShooter
//============================================================================



#include "Raumschiff.h"
#include "Raketen.h"
#include "Boesewichte.h"
#include "UtilsConsole.h"

#include <stdlib.h>

#include <time.h>



int breite = 79;
int hoehe = 20;



Raumschiff held(10,10);

Rakete rakete;

Raketen raketen;

Boesewichte boesewichte;



int munition = 30;

bool dauerfeuer = false;





void drawScreen(){
	system("cls");

	for(int i=0 ; i<breite ; i++){
		cout<<"*";
	}
	cout<<endl;


	for(int i=0 ; i<(hoehe-2); i++){
		cout<<"*";
		for(int j=0 ; j<(breite-2) ; j++){
			cout<<" ";
		}

		cout<<"*"<<endl;
	}

	for(int i=0 ; i<breite ; i++){
			cout<<"*";
	}



	UtilsConsole::setCursor(0,21);
	cout<<"Tasten:\nHoch:W  Runter:S  Links:A  Rechts:D\nDauerfeuer(AN/AUS):C  Feuer:Leertaste  Beenden:q";

}


void drawLandschaft(){



	string schicht1 = "     ^               __              ____=_          /\\          ";
	string schicht2 = "    / \\             (  ) 	     /______\\        /  \\       ";
	string schicht3 = "   /___\\        _____||_____        |[]  []|       /____\\       ";
	string schicht4 = "_____|____-----'            '--_____|__[]__|_________||______________________";





	UtilsConsole::setCursor(1,15);
	cout<<schicht1;
	UtilsConsole::setCursor(1,16);
	cout<<schicht2;
	UtilsConsole::setCursor(1,17);
	cout<<schicht3;
	UtilsConsole::setCursor(1,18);
	cout<<schicht4;



}




int main() {


		drawScreen();
		drawLandschaft();



		bool exit = false;

		held.setInit(true);
		held.setX(10);
		held.setY(10);

		held.draw();






		boesewichte.addNewBoesewicht();


		int fps = 0;
		time_t x = time(NULL);
		time_t y;

		while(!exit){



			y=time(NULL);


			UtilsConsole::setCursor(0,20);
			printf("Dauerfeuer: %s Munition: %4i",(dauerfeuer?"AN ":"AUS"),munition);

			if(y!=x){
				x=time(NULL);
				y=time(NULL);

				UtilsConsole::setCursor(72,0);
				cout<<"fps:"<<fps;
				fps = 0;
			}

			if(kbhit()){
				char c = getch();

				switch(c){
					case 'd':{
						held.goRight();


						break;
					}
					case 'a':{
						held.goLeft();


						break;
					}
					case 'w':{
						held.goUp();


						break;
					}
					case 's':{
						held.goDown();

						break;
					}


					case 'q':{
						exit = true;
						break;
					}


					case 'c':{

						if(!dauerfeuer){
							dauerfeuer = true;
						}else{
							dauerfeuer = false;
						}
						break;

					}

					case 0x20:{
						if(munition>0){
							raketen.addNewRakete(held.getX()+1,held.getY());
							munition--;
						}
						break;
					}
				}



			}

			if(fps%5==0 && dauerfeuer && munition>0){
				raketen.addNewRakete(held.getX()+1,held.getY());
				munition--;
			}

			if(munition<=0){
				dauerfeuer = false;
			}


			if(fps%20 == 0){
				munition++;
			}



			raketen.refresh();


			boesewichte.refresh();




			if(held.kollisionBoesewicht()){
				UtilsConsole::setCursor(30,10);
				cout<<"GAME OVER";


				UtilsConsole::setCursor(0,28);

				return 0;
			}



			UtilsConsole::setCursor(0,28);
			Sleep(30);

			fps++;


		}




		UtilsConsole::setCursor(0,28);

	return 0;
}




